
#include <sys/socket.h>
#include <sys/types.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/un.h>

int connection_handler(int socket_fd) {
  char buff[256];
  int nBytes = read(socket_fd, buff, 256);
  buff[nBytes] = 0;
  printf("message from client: %s\n", buff);
  nBytes = snprintf(buff, 256, "hello from server");
  write(socket_fd, buff, nBytes);

  close(socket_fd);
  return 0;
}
int server_listen(const char *fileName) {
  unlink(fileName);
  int socket_fd = socket(PF_UNIX, SOCK_STREAM, 0);
  struct sockaddr_un address;
  memset(&address, 0, sizeof(struct sockaddr_un));
  address.sun_family = AF_UNIX;
  sprintf(address.sun_path, "%s", fileName);

  bind(socket_fd, (struct sockaddr*)&address, sizeof(struct sockaddr_un));
  listen(socket_fd, 5);
  int connection_fd;
  socklen_t address_length;
  while((connection_fd = accept(socket_fd, (struct sockaddr*)&address, &address_length)) > (-1)) {
     int child = fork();
     if(child == 0) {
        return connection_handler(connection_fd);
     } else {
        close(connection_fd);
     }
  }
  fprintf(stderr, "accept returned %d\n", connection_fd);

  close(socket_fd);
  unlink(fileName);
  return 0;
}


int main() {

    server_listen("sockfile");
}
